local f = CreateFrame("Frame")
local bossLex = {
	[1] = "Goroth",
	[2] = "Demonic Inqiusition",
	[3] = "Harjatan",
	[4] = "Mistress Sassz'ine",
	[5] = "Sisters of the Moon",
	[6] = "Desolate Host",
	[7] = "Maiden of Vigilance",
	[8] = "Fallen Avatar",
	[9] = "Kil'jaeden",
}
local difficultyLex = {
	[14] = 2,
	[15] = 3,
	[16] = 4,
}
EnRT_BR_GUI = {}
local bonusRolls = 0
local spent = 0
local isLockMode = false
EnRT_BR_Settings = CreateFrame("Frame")
EnRT_BR_Settings:SetPoint("CENTER")
EnRT_BR_Settings:SetSize(240, 270)
EnRT_BR_Settings:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", --Set the background and border textures
	edgeFile = "Interface/Tooltips/UI-Tooltip-Border", 
	tile = true, tileSize = 16, edgeSize = 16, 
	insets = { left = 4, right = 4, top = 4, bottom = 4 }
})
EnRT_BR_Settings:SetBackdropColor(0,0,0,1)
EnRT_BR_Settings:Hide()

f:RegisterEvent("ENCOUNTER_END")
f:RegisterEvent("ZONE_CHANGED_NEW_AREA")
f:RegisterEvent("PLAYER_LOGIN")
local currentRaid = ""
f:SetScript("OnEvent", function(self, event, ...)
	if event == "ZONE_CHANGED_NEW_AREA" then
		if GetZoneText() == "Tomb of Sargeras" then
			bonusRolls = select(2,GetCurrencyInfo(1273))
			if bonusRolls > 0 then
				EnRT_BR_Settings:Show()
			end
		end
	elseif event == "ENCOUNTER_END" then
		local eID, eName, dID, raidSize, outcome = ...
		if EnRT_Contains(EnRT_BRBosses[currentRaid], eID) and outcome == 1 then
			local difficulty = select(3,GetInstanceInfo())
			if difficultyLex[difficulty] and EnRT_BRBosses[eName][difficultyLex[difficulty]] == 1 then
				AcceptSpellConfirmationPrompt(177539)
				--BONUS ROLL IT!!!!!!!!!!!!!!!!!! 177539 AcceptSpellConfirmationPrompt
				--[[
				/run local b = BonusRollButton or CreateFrame("Button", "BonusRollButton", nil, "SecureActionButtonTemplate") 
				b:SetAttribute("type", "click") 
				b:SetAttribute("clickbutton", BonusRollFrame.PromptFrame.RollButton)
				/click BonusRollButton
				]]
			else
				--SKIP IT!!!!!!!!!!!!!!!!!
			end
		end
	elseif event == "PLAYER_LOGIN" then
		if EnRT_BRBosses == nil then EnRT_BRArrayInit() end
		EnRT_BR_GUIInit()
	end
end)

function EnRT_Contains(arr, value)
	if value == nil then
		return false
	end
	if arr == nil then
		return false
	end
	for k, v in pairs(arr) do
		if v == value then
			return k
		end
	end
	return false
end

function EnRT_BRArrayInit()

	EnRT_BRBosses = {
		["Goroth"] = {2032,0,0,0},
		["Demonic Inqiusition"] = {2048,0,0,0},
		["Harjatan"] = {2036,0,0,0},
		["Mistress Sassz'ine"] = {2037,0,0,0},
		["Sisters of the Moon"] = {2050,0,0,0},
		["Desolate Host"] = {2054,0,0,0},
		["Maiden of Vigilance"] = {2052,0,0,0},
		["Fallen Avatar"] = {2038,0,0,0},
		["Kil'jaeden"] = {2051,0,0,0},
	}

end
function EnRT_BR_GUIInit()
	local diffs = {[1] = "N", [2] = "H", [3] = "M"}
	for k,v in pairs(diffs) do
		local diffText = EnRT_BR_Settings:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge")
		diffText:SetPoint("TOPLEFT", 18+(30*(k-1)), -15)
		diffText:SetText(v)
		EnRT_BR_GUI["diff"..v] = diffText
	end
	for i = 1, 9 do
		local bossName = bossLex[i]
		data = EnRT_BRBosses[bossName]
		local bossText = EnRT_BR_Settings:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge")
		bossText:SetPoint("TOPLEFT", 100, -15-(20*i))
		bossText:SetText(bossName)
		EnRT_BR_GUI[bossName] = bossText
		for j = 1, 3 do
			local bossDifButton = CreateFrame("CheckButton", "EnRT_BR_"..bossName..j, EnRT_BR_Settings, "UICheckButtonTemplate")
			bossDifButton:SetPoint("TOPLEFT", bossText, "TOPLEFT", -90+(30*(j-1)),5)
			bossDifButton:SetSize(26,26)
			bossDifButton:HookScript("OnClick", function(self)
				if self:GetChecked() then
					EnRT_BRBosses[bossName][j+1] = 1
					spent = spent + 1
					if spent >= bonusRolls and not isLockMode then
						EnRT_BR_Lock()
					end
					EnRT_BR_UpdateCoinText()
				else
					EnRT_BRBosses[bossName][j+1] = 0
					spent = spent - 1
					if spent < bonusRolls and isLockMode then
						EnRT_BR_Unlock()
					end
					if isLockMode then
						bossDifButton:Disable()
					end
					EnRT_BR_UpdateCoinText()
				end
			end)
			EnRT_BR_GUI[bossName..j] = bossDifButton
		end
	end
	local coinText = EnRT_BR_Settings:CreateFontString(nil, "ARTWORK", "GameFontNormal")
	coinText:SetPoint("BOTTOM", 0, 40)
	coinText:SetText("Remaning Coins: "..bonusRolls-spent)
	coinText:SetTextColor(0,1,0)
	EnRT_BR_GUI["coinText"] = coinText
	local closeButton = CreateFrame("Button", "EnRT_BR_CloseButton", EnRT_BR_Settings, "UIPanelButtonTemplate")
	closeButton:SetText("Save")
	closeButton:SetSize(120, 25)
	closeButton:SetPoint("BOTTOM", 0, 10)
	closeButton:HookScript("OnClick", function(self)
		EnRT_BR_Settings:Hide()
	end)
	EnRT_BR_GUI["closeButton"] = closeButton
end
EnRT_BR_Settings:SetScript("OnShow", function(self)
	for bossName, data in pairs(EnRT_BRBosses) do
		for i = 1, 3 do
			if data[i+1] == 1 then
				EnRT_BR_GUI[bossName..i]:SetChecked(true)
				spent = spent + 1
			end
		end
	end
	EnRT_BR_UpdateCoinText()
	if spent >= bonusRolls then
		EnRT_BR_Lock()
	end
end)
function EnRT_BR_Lock()
	for bossName, data in pairs(EnRT_BRBosses) do
		for i = 1, 3 do
			if data[i+1] == 0 then
				EnRT_BR_GUI[bossName..i]:Disable()
			end
		end
	end
	isLockMode = true
end
function EnRT_BR_Unlock()
	for bossName, data in pairs(EnRT_BRBosses) do
		for i = 1, 3 do
			EnRT_BR_GUI[bossName..i]:Enable()
		end
	end
	isLockMode = false
end
function EnRT_BR_UpdateCoinText()
	bonusRolls = select(2,GetCurrencyInfo(1273))
	EnRT_BR_GUI["coinText"]:SetText("Remaning Coins: "..bonusRolls-spent)
end
--2032,2048,2036,2050,2037,2054,2052,2038,2051